//
//  GearStyleKit.js
//  Gears
//
//  Created by Mike on 30.10.2016.
//  Copyright © 2016 PixelCut. All rights reserved.
//
//  Generated by PaintCode
//  http://www.paintcodeapp.com
//



//// APIs you can use in your code:
//
// Available methods for drawing into <canvas> elements:
//    GearStyleKit.drawGears(canvas, angle, targetFrame*, resizing*)
//
// NOTE: 'canvas' parameter can be either a <canvas> element object, or the id of a <canvas> element in your document.
//
// NOTE: Parameters marked with the '*' symbol are optional
//
// NOTE: Possible arguments for 'resizing' parameter in drawing methods are:
//   'aspectfit': The content is proportionally resized to fit into the target rectangle.
//   'aspectfill': The content is proportionally resized to completely fill the target rectangle.
//   'stretch': The content is stretched to match the entire target rectangle.
//   'center': The content is centered in the target rectangle, but it is NOT resized.
//
// Available Utilities:
//    GearStyleKit.clearCanvas(canvas)
//    GearStyleKit.makeRect(x, y, width, height)


//// Create StyleKit Object
var GearStyleKit = {};
(function() {

    //// Drawing Methods

    function drawGears(canvas, angle, targetFrame, resizing) {
        //// General Declarations
        canvas = initializeCanvas(typeof canvas === 'string' ? document.getElementById(canvas) : canvas);
        var context = canvas.getContext('2d');
        var pixelRatio = canvas.paintCodePixelRatio;
        
        //// Resize to Target Frame
        context.save();
        var resizedFrame = applyResizingBehavior(resizing, makeRect(0, 0, 240, 200), targetFrame);
        context.translate(resizedFrame.x, resizedFrame.y);
        context.scale(resizedFrame.w / 240, resizedFrame.h / 200);


        //// Color Declarations
        var color = 'rgba(69, 161, 212, 1)';
        var color2 = 'rgba(125, 189, 225, 1)';

        //// Variable Declarations
        var smallAngle = -angle / 2;

        //// Bezier Drawing
        context.save();
        context.translate(150, 96);
        context.rotate(-smallAngle * Math.PI / 180);

        context.beginPath();
        context.moveTo(2.78, -67.94);
        context.bezierCurveTo(3.71, -63.88, 4.74, -59.43, 5.59, -55.72);
        context.bezierCurveTo(7.73, -55.51, 9.84, -55.18, 11.9, -54.73);
        context.bezierCurveTo(13.87, -58, 16.21, -61.91, 18.36, -65.49);
        context.bezierCurveTo(20.15, -64.99, 21.91, -64.42, 23.64, -63.78);
        context.bezierCurveTo(23.27, -59.62, 22.87, -55.08, 22.54, -51.28);
        context.bezierCurveTo(24.5, -50.42, 26.4, -49.45, 28.23, -48.37);
        context.bezierCurveTo(31.11, -50.87, 34.55, -53.87, 37.69, -56.6);
        context.bezierCurveTo(39.24, -55.58, 40.73, -54.49, 42.18, -53.34);
        context.bezierCurveTo(40.55, -49.5, 38.77, -45.3, 37.28, -41.79);
        context.bezierCurveTo(38.87, -40.37, 40.37, -38.87, 41.79, -37.28);
        context.bezierCurveTo(45.3, -38.77, 49.5, -40.55, 53.34, -42.18);
        context.bezierCurveTo(54.49, -40.73, 55.58, -39.24, 56.6, -37.69);
        context.bezierCurveTo(53.87, -34.55, 50.87, -31.11, 48.37, -28.23);
        context.bezierCurveTo(49.45, -26.4, 50.42, -24.5, 51.28, -22.54);
        context.bezierCurveTo(55.08, -22.87, 59.62, -23.27, 63.78, -23.64);
        context.bezierCurveTo(64.42, -21.91, 64.99, -20.15, 65.49, -18.36);
        context.bezierCurveTo(61.91, -16.21, 58, -13.87, 54.73, -11.9);
        context.bezierCurveTo(55.18, -9.84, 55.51, -7.73, 55.72, -5.59);
        context.bezierCurveTo(59.43, -4.74, 63.88, -3.71, 67.94, -2.78);
        context.bezierCurveTo(67.98, -1.86, 68, -0.93, 68, 0);
        context.bezierCurveTo(68, 0.93, 67.98, 1.86, 67.94, 2.78);
        context.bezierCurveTo(63.88, 3.71, 59.43, 4.74, 55.72, 5.59);
        context.bezierCurveTo(55.51, 7.73, 55.18, 9.84, 54.73, 11.9);
        context.bezierCurveTo(58, 13.87, 61.91, 16.21, 65.49, 18.36);
        context.bezierCurveTo(64.99, 20.15, 64.42, 21.91, 63.78, 23.64);
        context.bezierCurveTo(59.62, 23.27, 55.08, 22.87, 51.28, 22.54);
        context.bezierCurveTo(50.42, 24.5, 49.45, 26.4, 48.37, 28.23);
        context.bezierCurveTo(50.87, 31.11, 53.87, 34.55, 56.6, 37.69);
        context.bezierCurveTo(55.58, 39.24, 54.49, 40.73, 53.34, 42.18);
        context.bezierCurveTo(49.5, 40.55, 45.3, 38.77, 41.79, 37.28);
        context.bezierCurveTo(40.37, 38.87, 38.87, 40.37, 37.28, 41.79);
        context.bezierCurveTo(38.77, 45.3, 40.55, 49.5, 42.18, 53.34);
        context.bezierCurveTo(40.73, 54.49, 39.24, 55.58, 37.69, 56.6);
        context.bezierCurveTo(34.55, 53.87, 31.11, 50.87, 28.23, 48.37);
        context.bezierCurveTo(26.4, 49.45, 24.5, 50.42, 22.54, 51.28);
        context.bezierCurveTo(22.87, 55.08, 23.27, 59.62, 23.64, 63.78);
        context.bezierCurveTo(21.91, 64.42, 20.15, 64.99, 18.36, 65.49);
        context.bezierCurveTo(16.21, 61.91, 13.87, 58, 11.9, 54.73);
        context.bezierCurveTo(9.84, 55.18, 7.73, 55.51, 5.59, 55.72);
        context.bezierCurveTo(4.74, 59.43, 3.71, 63.88, 2.78, 67.94);
        context.bezierCurveTo(1.86, 67.98, 0.93, 68, -0, 68);
        context.bezierCurveTo(-0.93, 68, -1.86, 67.98, -2.78, 67.94);
        context.bezierCurveTo(-3.71, 63.88, -4.74, 59.43, -5.59, 55.72);
        context.bezierCurveTo(-7.73, 55.51, -9.84, 55.18, -11.9, 54.73);
        context.bezierCurveTo(-13.87, 58, -16.21, 61.91, -18.36, 65.49);
        context.bezierCurveTo(-20.15, 64.99, -21.91, 64.42, -23.64, 63.78);
        context.bezierCurveTo(-23.27, 59.62, -22.87, 55.08, -22.54, 51.28);
        context.bezierCurveTo(-24.5, 50.42, -26.4, 49.45, -28.23, 48.37);
        context.bezierCurveTo(-31.11, 50.87, -34.55, 53.87, -37.69, 56.6);
        context.bezierCurveTo(-39.24, 55.58, -40.73, 54.49, -42.18, 53.34);
        context.bezierCurveTo(-40.55, 49.5, -38.77, 45.3, -37.28, 41.79);
        context.bezierCurveTo(-38.87, 40.37, -40.37, 38.87, -41.79, 37.28);
        context.bezierCurveTo(-45.3, 38.77, -49.5, 40.55, -53.34, 42.18);
        context.bezierCurveTo(-54.49, 40.73, -55.58, 39.24, -56.6, 37.69);
        context.bezierCurveTo(-53.87, 34.55, -50.87, 31.11, -48.37, 28.23);
        context.bezierCurveTo(-49.45, 26.4, -50.42, 24.5, -51.28, 22.54);
        context.bezierCurveTo(-55.08, 22.87, -59.62, 23.27, -63.78, 23.64);
        context.bezierCurveTo(-64.42, 21.91, -64.99, 20.15, -65.49, 18.36);
        context.bezierCurveTo(-61.91, 16.21, -58, 13.87, -54.73, 11.9);
        context.bezierCurveTo(-55.18, 9.84, -55.51, 7.73, -55.72, 5.59);
        context.bezierCurveTo(-59.43, 4.74, -63.88, 3.71, -67.94, 2.78);
        context.bezierCurveTo(-67.98, 1.86, -68, 0.93, -68, 0);
        context.bezierCurveTo(-68, -0.93, -67.98, -1.86, -67.94, -2.78);
        context.bezierCurveTo(-63.88, -3.71, -59.43, -4.74, -55.72, -5.59);
        context.bezierCurveTo(-55.51, -7.73, -55.18, -9.84, -54.73, -11.9);
        context.bezierCurveTo(-58, -13.87, -61.91, -16.21, -65.49, -18.36);
        context.bezierCurveTo(-64.99, -20.15, -64.42, -21.91, -63.78, -23.64);
        context.bezierCurveTo(-59.62, -23.27, -55.08, -22.87, -51.28, -22.54);
        context.bezierCurveTo(-50.42, -24.5, -49.45, -26.4, -48.37, -28.23);
        context.bezierCurveTo(-50.87, -31.11, -53.87, -34.55, -56.6, -37.69);
        context.bezierCurveTo(-55.58, -39.24, -54.49, -40.73, -53.34, -42.18);
        context.bezierCurveTo(-49.5, -40.55, -45.3, -38.77, -41.79, -37.28);
        context.bezierCurveTo(-40.37, -38.87, -38.87, -40.37, -37.28, -41.79);
        context.bezierCurveTo(-38.77, -45.3, -40.55, -49.5, -42.18, -53.34);
        context.bezierCurveTo(-41.55, -53.84, -40.91, -54.33, -40.26, -54.81);
        context.bezierCurveTo(-39.42, -55.43, -38.56, -56.03, -37.69, -56.6);
        context.bezierCurveTo(-34.55, -53.87, -31.11, -50.87, -28.23, -48.37);
        context.bezierCurveTo(-26.4, -49.45, -24.5, -50.42, -22.54, -51.28);
        context.bezierCurveTo(-22.87, -55.08, -23.27, -59.62, -23.64, -63.78);
        context.bezierCurveTo(-21.91, -64.42, -20.15, -64.99, -18.36, -65.49);
        context.bezierCurveTo(-16.21, -61.91, -13.87, -58, -11.9, -54.73);
        context.bezierCurveTo(-9.84, -55.18, -7.73, -55.51, -5.59, -55.72);
        context.bezierCurveTo(-4.74, -59.43, -3.71, -63.88, -2.78, -67.94);
        context.bezierCurveTo(-1.93, -67.98, -1.08, -68, -0.23, -68);
        context.lineTo(0, -68);
        context.bezierCurveTo(0.93, -68, 1.86, -67.98, 2.78, -67.94);
        context.closePath();
        context.moveTo(0, -36);
        context.bezierCurveTo(-6.22, -36, -12.07, -34.42, -17.18, -31.65);
        context.bezierCurveTo(-28.39, -25.55, -36, -13.66, -36, 0);
        context.bezierCurveTo(-36, 19.88, -19.88, 36, 0, 36);
        context.bezierCurveTo(19.88, 36, 36, 19.88, 36, 0);
        context.bezierCurveTo(36, -19.88, 19.88, -36, 0, -36);
        context.closePath();
        context.fillStyle = color;
        context.fill();

        context.restore();


        //// Bezier 2 Drawing
        context.save();
        context.translate(62, 137);
        context.rotate(-angle * Math.PI / 180);

        context.beginPath();
        context.moveTo(2.12, -37.94);
        context.lineTo(2.45, -37.92);
        context.bezierCurveTo(3.29, -34.48, 4.2, -30.71, 4.97, -27.56);
        context.bezierCurveTo(6.23, -27.34, 7.46, -27.03, 8.65, -26.64);
        context.bezierCurveTo(9.87, -26.24, 11.04, -25.77, 12.18, -25.22);
        context.bezierCurveTo(14.65, -27.32, 17.61, -29.83, 20.31, -32.12);
        context.bezierCurveTo(21.69, -31.25, 23.02, -30.28, 24.27, -29.24);
        context.bezierCurveTo(22.92, -25.96, 21.45, -22.37, 20.22, -19.37);
        context.bezierCurveTo(21.97, -17.55, 23.47, -15.49, 24.68, -13.24);
        context.bezierCurveTo(27.91, -13.49, 31.78, -13.78, 35.32, -14.05);
        context.bezierCurveTo(35.92, -12.54, 36.42, -10.99, 36.83, -9.39);
        context.bezierCurveTo(33.81, -7.53, 30.5, -5.49, 27.75, -3.79);
        context.bezierCurveTo(27.91, -2.55, 28, -1.29, 28, 0);
        context.bezierCurveTo(28, 1.29, 27.91, 2.55, 27.75, 3.79);
        context.bezierCurveTo(30.51, 5.49, 33.81, 7.53, 36.83, 9.39);
        context.bezierCurveTo(36.42, 10.99, 35.92, 12.54, 35.32, 14.05);
        context.bezierCurveTo(31.78, 13.78, 27.91, 13.49, 24.68, 13.24);
        context.bezierCurveTo(23.47, 15.49, 21.97, 17.55, 20.22, 19.37);
        context.bezierCurveTo(21.45, 22.37, 22.92, 25.96, 24.27, 29.24);
        context.bezierCurveTo(23.02, 30.28, 21.69, 31.25, 20.31, 32.12);
        context.bezierCurveTo(17.61, 29.83, 14.65, 27.32, 12.18, 25.22);
        context.bezierCurveTo(9.93, 26.31, 7.51, 27.11, 4.97, 27.56);
        context.bezierCurveTo(4.2, 30.71, 3.29, 34.48, 2.45, 37.92);
        context.bezierCurveTo(1.64, 37.97, 0.82, 38, -0, 38);
        context.bezierCurveTo(-0.82, 38, -1.64, 37.97, -2.45, 37.92);
        context.bezierCurveTo(-3.29, 34.48, -4.2, 30.71, -4.97, 27.56);
        context.bezierCurveTo(-7.51, 27.11, -9.93, 26.31, -12.18, 25.22);
        context.bezierCurveTo(-14.65, 27.32, -17.61, 29.83, -20.31, 32.12);
        context.bezierCurveTo(-21.69, 31.25, -23.02, 30.28, -24.27, 29.24);
        context.bezierCurveTo(-22.92, 25.96, -21.45, 22.37, -20.22, 19.37);
        context.bezierCurveTo(-21.97, 17.55, -23.47, 15.49, -24.68, 13.24);
        context.bezierCurveTo(-27.91, 13.49, -31.78, 13.78, -35.32, 14.05);
        context.bezierCurveTo(-35.92, 12.54, -36.42, 10.99, -36.83, 9.39);
        context.bezierCurveTo(-33.81, 7.53, -30.5, 5.49, -27.75, 3.79);
        context.bezierCurveTo(-27.91, 2.55, -28, 1.29, -28, 0);
        context.bezierCurveTo(-28, -1.29, -27.91, -2.55, -27.75, -3.79);
        context.bezierCurveTo(-30.51, -5.49, -33.81, -7.53, -36.83, -9.39);
        context.bezierCurveTo(-36.42, -10.99, -35.92, -12.54, -35.32, -14.05);
        context.bezierCurveTo(-31.78, -13.78, -27.91, -13.49, -24.68, -13.24);
        context.bezierCurveTo(-23.47, -15.49, -21.97, -17.55, -20.22, -19.37);
        context.bezierCurveTo(-21.45, -22.37, -22.92, -25.96, -24.27, -29.24);
        context.bezierCurveTo(-23.02, -30.28, -21.69, -31.25, -20.31, -32.12);
        context.bezierCurveTo(-17.61, -29.83, -14.65, -27.32, -12.18, -25.22);
        context.bezierCurveTo(-9.93, -26.31, -7.51, -27.11, -4.97, -27.56);
        context.bezierCurveTo(-4.2, -30.71, -3.29, -34.48, -2.45, -37.92);
        context.bezierCurveTo(-1.64, -37.97, -0.82, -38, 0, -38);
        context.bezierCurveTo(0.71, -38, 1.42, -37.98, 2.12, -37.94);
        context.closePath();
        context.moveTo(0, -14);
        context.bezierCurveTo(-7.73, -14, -14, -7.73, -14, 0);
        context.bezierCurveTo(-14, 7.73, -7.73, 14, 0, 14);
        context.bezierCurveTo(7.73, 14, 14, 7.73, 14, 0);
        context.bezierCurveTo(14, -5.48, 10.85, -10.22, 6.27, -12.52);
        context.bezierCurveTo(4.38, -13.47, 2.25, -14, 0, -14);
        context.closePath();
        context.fillStyle = color2;
        context.fill();

        context.restore();
        
        context.restore();

    }

    //// Infrastructure

    function clearCanvas(canvas) {
        canvas = initializeCanvas(typeof canvas === 'string' ? document.getElementById(canvas) : canvas);
        canvas.getContext('2d').clearRect(0, 0, canvas.width, canvas.height);
    }

    // Possible arguments for 'resizing' parameter are:
    //   'aspectfit': The content is proportionally resized to fit into the target rectangle.
    //   'aspectfill': The content is proportionally resized to completely fill the target rectangle.
    //   'stretch': The content is stretched to match the entire target rectangle.
    //   'center': The content is centered in the target rectangle, but it is NOT resized.
    function applyResizingBehavior(resizing, rect, targetRect) {
        if (targetRect === undefined || equalRects(rect, targetRect) || equalRects(targetRect, makeRect(0, 0, 0, 0))) {
            return rect;
        }

        var scales = makeSize(0, 0);
        scales.w = Math.abs(targetRect.w / rect.w);
        scales.h = Math.abs(targetRect.h / rect.h);

        switch (resizing) {
            case 'aspectfit': {
                scales.w = Math.min(scales.w, scales.h);
                scales.h = scales.w;
                break;
            }
            case 'aspectfill': {
                scales.w = Math.max(scales.w, scales.h);
                scales.h = scales.w;
                break;
            }
            case 'stretch':
            case undefined:
                break;
            case 'center': {
                scales.w = 1;
                scales.h = 1;
                break;
            }
            default:
                throw 'Unknown resizing behavior "' + resizing + '". Use "aspectfit", "aspectfill", "stretch" or "center" as resizing behavior.';
        }

        var result = makeRect(Math.min(rect.x, rect.x + rect.w), Math.min(rect.y, rect.y + rect.h), Math.abs(rect.w), Math.abs(rect.h));
        result.w *= scales.w;
        result.h *= scales.h;
        result.x = targetRect.x + (targetRect.w - result.w) / 2;
        result.y = targetRect.y + (targetRect.h - result.h) / 2;
        return result;
    }

    function makeRect(x, y, w, h) {
        return { x: x, y: y, w: w, h: h };
    }

    function equalRects(r1, r2) {
        return r1.x === r2.x && r1.y === r2.y && r1.w == r2.w && r1.h === r2.h;
    }

    function makeSize(w, h) {
        return { w: w, h: h };
    }

    function initializeCanvas(canvas) {
        if ('paintCodePixelRatio' in canvas) return canvas;
        // This function should only be called once on each canvas.
        var context = canvas.getContext('2d');

        var devicePixelRatio = window.devicePixelRatio || 1;
        var backingStorePixelRatio = context.webkitBackingStorePixelRatio
            || context.mozBackingStorePixelRatio
            || context.msBackingStorePixelRatio
            || context.oBackingStorePixelRatio
            || context.backingStorePixelRatio
            || 1;

        var pixelRatio = devicePixelRatio / backingStorePixelRatio;

        canvas.style.width = canvas.width + 'px';
        canvas.style.height = canvas.height + 'px';
        canvas.width *= pixelRatio;
        canvas.height *= pixelRatio;
        canvas.paintCodePixelRatio = pixelRatio;

        context.scale(pixelRatio, pixelRatio);
        return canvas;
    }

    //// Public Interface

    // Drawing Methods
    GearStyleKit.drawGears = drawGears;

    // Utilities
    GearStyleKit.clearCanvas = clearCanvas;
    GearStyleKit.makeRect = makeRect;

})();
